

#ifndef subsystems_threadx_thread_H 

#define subsystems_threadx_thread_H 


#include <tx_api.h>

//----------------------------------------------------------------------------
// subsystems/threadx/thread.h                                                                  
//----------------------------------------------------------------------------

//## class thread 
class thread  {


////    Constructors and destructors    ////
public :
    
    //## operation thread(void *,unsigned long) 
    thread(void * p_stack_start, unsigned long ul_stack_size);
    
    //## operation thread() 
    thread();
    
    //## operation ~thread() 
    virtual ~thread();


////    Operations    ////
public :
    
    unsigned int Create(char* name_ptr, unsigned long entry_input, unsigned int priority, unsigned int preempt_threshold, unsigned long time_slice, unsigned int auto_start);


    //## operation Delete() 
    unsigned int Delete();
    
    //## operation Execute(unsigned long) 
    virtual void Execute(ULONG entry_input)=0;
    
   



////    Attributes    ////
protected :
    
    unsigned long stack_size;		//## attribute stack_size 
    
    void * stack_start;		//## attribute stack_start 
    
    TX_THREAD * thread_ptr;		//## attribute thread_ptr 


};


#endif  

